// CMSC427 Lab 4 Fall 2017
// HelixFly2.pde
// Draw a parametric "crown" in 3D
// Use Frenet frame to align boxes with curve 
// R. Eastman

void setup() {
size(600,600,P3D);
colorMode(HSB,360,100,100);
}

void draw() {
background(0,0,0);
translate(width/2,height/2);
rotateY(mouseX*PI/width);
rotateX(mouseY*PI/height);
for (float t = 0; t < 10*2*PI; t+=0.05) {
    float x = 200*cos(t);
    float y = 100*sin(10*t);
    float z = 200*sin(t);
    fill(1.3*(x+100),abs(10*y),100,128);
    // We push the matrix for each box so translations don't accumulate
    pushMatrix(); 
      translate(x,100-y,z);
      //applyFrenet(t); // Correct the method and then uncomment this
      scale(1,1,2);
      box(10);
    popMatrix();
}
}

// Method to create a local coordinate system
// and then generate a rotation matrix
// This version is valid for a helix curve
// INVALID IN THIS PROGRAM ...
void applyFrenet( float t ) {
    // Tangent
    float tx = -10*sin(t)/sqrt(101);
    float ty = -1/sqrt(101);   
    float tz = 10*cos(t)/sqrt(101);
    // Curvature
    float nx = -cos(t);   
    float ny = 0;   
    float nz = -sin(t);
    // Binormal
    float bx = sin(t)/sqrt(101);
    float by = -10/sqrt(101);
    float bz = -cos(t)/sqrt(101);
    applyMatrix(bx, nx, tx, 0,
                by, ny, ty, 0,
                bz, nz, tz, 0,
                0,  0,  0,  1);
}